///--------------------------------------------------------------------------//
///	@pgm		
///	@version	0.01
///	@date		2007/03/06
///	@author 	؂񂬂񂭂
///	@remarks	
///
///--------------------------------------------------------------------------//
#include <avr/io.h>
#define	__AVR_HAVE_LPMX__	1
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <avr/interrupt.h>
#include <compat/deprecated.h>
#include <stdio.h>

#define _DEF_CPU 1000000UL  				// ftHgCPUx 1 MHzƂ
#define	CPUX	 (F_CPU / _DEF_CPU)			// ftHgCPỦ{`(F_CPU̓vWFNgIvV)
//----------------------------------------------------------------------------//
///	@macros		萔`
//----------------------------------------------------------------------------//
#define	CNT_1S_1024DIV				((unsigned)(976.5 * CPUX))
#define	CNT_500MS_1024DIV			((unsigned)(488.3 * CPUX))
#define	CNT_300MS_1024DIV			((unsigned)(293 * CPUX))
#define	CNT_200MS_1024DIV			((unsigned)(195.3 * CPUX))
#define	CNT_5MS_64DIV_256DIV		((unsigned)(0.3 * CPUX))
#define	CNT_5MS_1024DIV				((unsigned)(4.88 * CPUX))
#define	CNT_1MS_64DIV				((unsigned)(15.62 * CPUX))
#define	CNT_4100US_1024DIV			((unsigned)(4 * CPUX))
#define	CNT_500US_64DIV				((unsigned)(7.81 * CPUX))
#define	CNT_300US_64DIV				((unsigned)(4.69 * CPUX))
#define	CNT_100US_64DIV				((unsigned)(1.56 * CPUX))
#define	CNT_20US_64DIV				((unsigned)(0.31 * CPUX))
#define	CNT_13US_64DIV				((unsigned)(0.2 * CPUX))

#define	STARTUP_WAIT				CNT_300MS_1024DIV
#define	USART_BAURATE				9600UL		// ʐM{[[g
#define	USART_TIMEOUT				CNT_200MS_1024DIV		// 0.2b^CAEgƂ

#define	_B_REG_SEL					PA1
#define	_B_ENABLE					PA0
#define	_B_SEL_L					PD2
#define	_B_SEL_R					PD3
#define	_B_SEL_U					PD5
#define	_B_SEL_D					PD4
#define	_B_ENTER					PD6
#define	MASK_BUTTON					(1 << _B_SEL_L | 1 << _B_SEL_R | 1 << _B_SEL_U | 1 << _B_SEL_D | 1 << _B_ENTER)
#define	PIN_BUTTON					PIND
#define	POR_BUTTON					PORD

#define	DCMD_FUNC_SET				0b00111100
#define	DCMD_DISP_ON				0b00001100
#define	DCMD_DISP_OFF				0b00001000
#define	FLG_DISP_CURSOR				(1 << 1)
#define	FLG_DISP_BLINK				(1 << 0)
#define	DCMD_CLEAR					0b00000001
#define	DCMD_ENTRY_R				0b00000110
#define	DCMD_ENTRY_L_SHIFT			0b00000111
#define	DCMD_CURSOR_HOME			0b00000010
#define	DCMD_ADDR_LEFT0				0b10000000
#define	DCMD_ADDR_RIGHT0			0b11000000
#define	DCMD_ADDR_RIGHT7			0b11000111
#define	LCD_DIST_LEFT				0
#define	LCD_DIST_RIGHT				1

//!	bFlags ̃rbgtO`
#define	BF_BUTON_REQ				0
#define BF_SEL_L_PUSH				2
#define	BF_SEL_R_PUSH				3	
#define	BF_SEL_U_PUSH				4	
#define	BF_SEL_D_PUSH				5	
#define	BF_ENTER_PUSH				6
#define	BF_SETUP					7

//!	bFlags2 ̃rbgtO`
#define	BF_MODIFY					0
#define	BF_ENTER_DBLCLK				1
#define BF_SEL_L_UP					2
#define	BF_SEL_R_UP					3	
#define BF_SEL_L_PUSHING			4
#define BF_SEL_R_PUSHING			5

//	RS-232C ʐMp R}h
#define	_SCMD_WKUP1		'*'
#define	_SCMD_WKUP2		'!'
#define	_RCMD_SETUP0	's'
#define	_RCMD_SETUP1	'u'
#define	_RCMD_SETUP2	'@'
#define	_SCMD_DUMMY		'|'
#define	_SCMDS_SETUP 	"su"
#define	_SCMDS_DUMMY	"||"
#define	_SCMDS_FINISH	"f@?"

#define	_SCMD_GETAT0	'g'
#define	_SCMD_GETAT1	'@'
#define	_SCMD_SETAT0	's'
#define	_SCMD_SETAT1	'@'
#define	_RCMD_OK		0xfa
#define	_RCMD_BAD		0xfd
	

#define	IsBitSet(Char, nBit)	(Char & (1 << nBit))
#define	IsBitClear(Char, nBit)	(!(Char & (1 << nBit)))
#define	BitSet(Char, nBit)		(Char |= (1 << nBit))
#define	BitsSet(Char, B1, B2)	(Char |= (1 << B1 | 1 << B2))
#define	BitClear(Char, nBit)	(Char &= ~(1 << nBit))

#define	nop()	{ asm volatile("nop"); }

void	Waitus(unsigned	us)
{
	TCCR1B 	= 0b00000010;				// ^C}P8
	TIFR	= (1 << TOV1);
	TCNT1 	= ~us;
	while(!(TIFR & (1 << TOV1)));
}

/*
void	Waitms(unsigned ms)
{
	ms 		= ms >> 3;
	TCCR1B 	= 0b00000101;				// ^C}P1024
	TIFR	= (1 << TOV1);
	TCNT1 	= ~ms;
	while(!(TIFR & (1 << TOV1)));
}
*/

/*
void	StopWatchStart(unsigned tout)		
{
 	TCCR1B 	= 0b00000101; 				//	^C}P1024
	TCNT1	= ~tout;					// ^CAEgԃZbg	
	(TIFR	= (1 << TOV1)); 			// I[o[t[rbgNA 
}

#define	IsTimeOut()			((TIFR & (1 << TOV1)))
*/

void PulsEnable()
{
	BitSet(PORTA, _B_ENABLE);
	nop();
	nop();
	nop();
	nop();
	BitClear(PORTA, _B_ENABLE);
}

void	InitializeLCD()
{
	//	t@NVZbg4.1ms҂
	BitClear(PORTA, _B_REG_SEL);
	PORTB	= DCMD_FUNC_SET;
	PulsEnable();
	Waitus(4200);

	//	t@NVZbg100us҂
	BitClear(PORTA, _B_REG_SEL);
	PORTB	= DCMD_FUNC_SET;
	PulsEnable();
	Waitus(200);

	//	t@NVZbg
	BitClear(PORTA, _B_REG_SEL);
	PORTB	= DCMD_FUNC_SET;
	PulsEnable();
	Waitus(50);

	//	t@NVZbg
	BitClear(PORTA, _B_REG_SEL);
	PORTB	= DCMD_FUNC_SET;
	PulsEnable();
	Waitus(50);
/*
	//	\It
	BitClear(PORTA, _B_REG_SEL);
	PORTB	= 	DCMD_DISP_OFF;
	PulsEnable();
	Waitus(50);
*/
	//	NA
	BitClear(PORTA, _B_REG_SEL);
	PORTB	= 	DCMD_CLEAR;
	PulsEnable();
	Waitus(1640);

	//	Gg[[hZbg
	BitClear(PORTA, _B_REG_SEL);
	PORTB	= 	DCMD_ENTRY_R;
	PulsEnable();
	Waitus(50);

	//	\I
	BitClear(PORTA, _B_REG_SEL);
	PORTB	= 	DCMD_DISP_ON | FLG_DISP_CURSOR;
	PulsEnable();
	Waitus(50);

}

void	LCDPutByte(char	c)
{
	BitSet(PORTA, _B_REG_SEL);
	PORTB	= 	c;
	PulsEnable();
	Waitus(50);
}

void	LCDPutLine(char	dist, char *psz)
{
	char	i, c;
//
	BitClear(PORTA, _B_REG_SEL);
	if(dist == 1)
		PORTB	= 	DCMD_ADDR_RIGHT0;
	else
		PORTB	= 	DCMD_ADDR_LEFT0;
	PulsEnable();
	Waitus(50);

	for(i = 0; i < 8; i++)
	{
		if(*psz)
		{
			c = *psz;
			psz++;
		}
		else
			c = ' ';
		LCDPutByte(c);
	}
}

void	LCDPutsNumeric(char dist, unsigned num)
{
	char	datas[9], 
			i;
//
	datas[8]	= 0;
	i = 7;
	while(num > 0)
	{
		datas[i] = (num % 10) + 0x30;
		num /= 10;
		i--;
	}
	while(i >= 0)
	{
		datas[i] = ' ';
		i--;
	}
	LCDPutLine(dist, datas);
}

void	LCDClear(char	dist)
{
	char	i;
//
	BitClear(PORTA, _B_REG_SEL);
	if(dist == 1)
		PORTB	= 	DCMD_ADDR_RIGHT0;
	else
		PORTB	= 	DCMD_ADDR_LEFT0;
	PulsEnable();
	Waitus(50);

	for(i = 0; i < 8; i++)
		LCDPutByte(' ');
}

///-----------------------------------------------------------//
///	@func	USARTGetByte
///	@brief	PoCg̎M(A^CAEgԂ0.2bƂ)
///	@return	SđMł0(A0𑗂肽ꍇ͂łȂ)
///-----------------------------------------------------------//
/*
uint8_t	USARTGetByte()
{
	uint8_t	dummy;
	while(!IsBitSet(UCSRA, RXC));

	if(UCSRA & (1 << FE | 1 << DOR | 1 << UPE))
	{
		while(IsBitSet(UCSRA, RXC))
			dummy = UDR;
		return  0xff;
	}
	return  UDR;
}
*/

///-----------------------------------------------------------//
///	@func	USARTGetByte
///-----------------------------------------------------------//
uint8_t	USARTGetByte(uint8_t *pError, unsigned tout)
{
	uint8_t	cGet, nRet, seq = 0;
//
	TCCR1B 	= 0b00000101;						// ^C}P1024
	TCNT1	= ~tout;							// 
	BitSet(TIFR, TOV1);							// I[o[t[rbgNA
	while(!IsBitSet(TIFR, TOV1))
	{
		if(!seq)
		{
			if(UCSRA & (1 << RXC | 1 << FE | 1 << DOR | 1 << UPE))
			{
				if(UCSRA & (1 << FE | 1 << DOR | 1 << UPE))
				{
					while(IsBitSet(UCSRA, RXC))		// ǂݎ̂
						cGet = UDR;
					nRet = 1;
				}
				else
				{
					cGet = UDR;
					nRet = 0;						// 
				}
				seq++;
			}
		}
		else
		{
			if(IsBitSet(UCSRA, UDRE))				// Mobt@󂢂
			{
				UDR	= nRet;								// ^[R[hM
				break;
			}
		}
	}

	if(IsBitSet(TIFR, TOV1))
		*pError = 0xff;
	else
		*pError = nRet;	
	return  cGet;
}

uint8_t	USARTPutByte(uint8_t c, unsigned tout)
{
	uint8_t	seq = 0, ret;
//
	TCCR1B 	= 0b00000101;						// ^C}P1024
	TCNT1	= ~tout;							// 
	BitSet(TIFR, TOV1);							// I[o[t[rbgNA

	while(!IsBitSet(TIFR, TOV1))
	{
		if(!seq)
		{
			if(IsBitSet(UCSRA, UDRE))
			{
				UDR	= c;
				seq++;
			}
		}
		else
		{
			if(UCSRA & (1 << RXC | 1 << FE | 1 << DOR | 1 << UPE))
			{
				ret = UDR;
				return  ret;
			}

		}

	}
	if(IsBitSet(TIFR, TOV1))
		return  0xff;
	return  0;
}

///-----------------------------------------------------------//
///	@func	USARTPutDatas
///	@brief	f[^̑M(A^CAEgԂ0.2bƂ)
///	@return	SđMł0
///-----------------------------------------------------------//
uint8_t	USARTPutDatas(uint8_t num, uint8_t *p)
{
	uint8_t	ret;
	while(num)
	{
		if((ret = USARTPutByte(*p++, CNT_1S_1024DIV)) != 0)
			break;
		num--;
	}
	return  ret;
}

//-----------------------------------------------------------//
///	@func	ChkConnect
///	@brief	CDI{̂ƒʐMĐڑĂ邩`FbN
//-----------------------------------------------------------//
uint8_t	ChkConnect()
{
	uint8_t		uTemp,
				uRet;
//
	uTemp = USARTGetByte(&uRet, CNT_1S_1024DIV);
	if(uRet != 0 || uTemp != _SCMD_WKUP1)
		return  0;
	uTemp = USARTGetByte(&uRet, CNT_1S_1024DIV);
	if(uRet != 0 || uTemp != _SCMD_WKUP2)
		return  0;
	return  3;

}

//-----------------------------------------------------------//
///	@func	main
///	@brief	vÕGg[|Cg
//-----------------------------------------------------------//
int	main(void)
{
	uint8_t		uTemp,
				idxCur, 
				idxPrev, 
				nError = 0,
				uXOR,
				uMaxRpmP100,
				uBtnPortSav,
				uBtnPortShot = 0,
				bFlags 	= 0,
				bFlags2	= 0,
				uAngle = 0,
				uAngleSav = 0,
				uSends[4],
				uTimer3 = 0,
				uRet,
				cnEntry = 0;
	char		retry;
	unsigned	uCalc;
//
	//------ X^[gAbvEFCg--------------//
	TCCR1B 	= 0b00000101;				// ^C}P1024iEFCNAbvpWaiẗׁj
	TCNT1	= ~(STARTUP_WAIT);
	while(!(TIFR & (1 << TOV1)));		// ҋ@
//
	DDRB		= 0xff;					// PORTB ͑Sďo
	DDRA		= (1 << _B_REG_SEL | 1 << _B_ENABLE);
//
	PORTD		= MASK_BUTTON;
	uBtnPortSav = PIN_BUTTON & MASK_BUTTON;
//
	InitializeLCD();
	TCCR0B	= 0b00000101;				// ^C}01024
	//----- VAʐMݒ --------------------//
	UBRRL	= (F_CPU / (16 * USART_BAURATE)) - 1;
	UCSRB	= (1 << RXEN | 1 << TXEN | 0 << RXCIE | 0 << TXCIE);	//	M, 荞݂s
//	UCSRC	= 0b00000110;				// 񓯊EpeBAXgbvrbgPAf[^rbgW
	UCSRC	= 0b00111110;			// 񓯊EpeBAXgbvrbgQAf[^rbgW
//

	LCDPutLine(0, "START") ;
	// CDI ̐ڑ`FbN
	if(ChkConnect() != 3)
	{
		LCDPutLine(0, "CDI NOT") ;
		LCDPutLine(1, "CONNET");
		return	-1;
	}

//	ʏ	
	if(!IsBitSet(PIN_BUTTON, _B_ENTER))	// NENTER{^Ăꍇ
	{
		if((uRet = USARTPutDatas(2, _SCMDS_SETUP)) != 0)
		{
			nError = 1;
			goto	LERROR;
		}
		LCDPutLine(0, "SETTING") ;
		LCDPutLine(1, "MODE");
		BitSet(bFlags, BF_SETUP);
	}
	else
	{
		USARTPutDatas(2, _SCMDS_DUMMY);
		BitClear(bFlags, BF_SETUP);
	}

//
	// CDI Ƃ̒ʐMƃf[^XVC

	//	ō]100Ŋ̂CDI󂯎
	uMaxRpmP100 = USARTGetByte(&uRet, CNT_1S_1024DIV);
	if(uRet != 0)
	{
		nError = 2;
		goto	LERROR;
	}

	cnEntry = USARTGetByte(&uRet, CNT_1S_1024DIV);
	if(uRet != 0)
	{
		nError = 3;
		goto	LERROR;
	}

	idxCur = cnEntry;
	idxPrev = idxCur;


	while(IsBitSet(bFlags, BF_SETUP))
	{
		if(IsBitSet(TIFR , TOV0))		// ^C}ÕI[o[t[̏vԂ͂RQ~b
		{
			TIFR	= (1 << TOV0);
			uTimer3++;
			if(uTimer3 >= 6)			// 32mbX6 0.2b
			{
				uTimer3 = 0;
				if(IsBitSet(bFlags2, BF_SEL_L_PUSHING))
					BitSet(bFlags, BF_SEL_L_PUSH);
				else
				if(IsBitSet(bFlags2, BF_SEL_R_PUSHING))
					BitSet(bFlags, BF_SEL_R_PUSH);

			}
		}
		if(IsBitSet(bFlags, BF_BUTON_REQ))
		{
			if(TCNT0 >= CNT_5MS_1024DIV)
			{	
				uTemp = (PIN_BUTTON & MASK_BUTTON);
				if(uTemp != uBtnPortSav)
				{
					uXOR = uTemp ^ uBtnPortSav;
					if(IsBitSet(uXOR, _B_SEL_L))
					{
						if(!IsBitSet(uTemp, _B_SEL_L))
							BitSet(bFlags, BF_SEL_L_PUSH);
						else
							BitSet(bFlags2, BF_SEL_L_UP);
					}
					if(IsBitSet(uXOR, _B_SEL_R))
					{
						if(!IsBitSet(uTemp, _B_SEL_R))
							BitSet(bFlags, BF_SEL_R_PUSH);
						else
							BitSet(bFlags2, BF_SEL_R_UP);
					}
					if(IsBitSet(uXOR, _B_SEL_U))
					{
						if(!IsBitSet(uTemp, _B_SEL_U))
							BitSet(bFlags, BF_SEL_U_PUSH);
					}
					if(IsBitSet(uXOR, _B_SEL_D))
					{
						if(!IsBitSet(uTemp, _B_SEL_D))
							BitSet(bFlags, BF_SEL_D_PUSH);
					}
					if(IsBitSet(uXOR, _B_ENTER))
					{
						if(!IsBitSet(uTemp, _B_ENTER))
							BitSet(bFlags, BF_ENTER_PUSH);
					}
					uBtnPortSav = uTemp;
				}
				TCNT0	= 0;
				TIFR	= (1 << TOV0);
				BitClear(bFlags, BF_BUTON_REQ);
			}
			else
			{
				if((PIN_BUTTON & MASK_BUTTON) != uBtnPortShot)
					BitClear(bFlags, BF_BUTON_REQ);
			}
		}
		else
		{
			if((PIN_BUTTON & MASK_BUTTON) != uBtnPortSav)
			{
				uBtnPortShot = (PIN_BUTTON & MASK_BUTTON);
				BitSet(bFlags, BF_BUTON_REQ);
				TCNT0	= 0;
				uTimer3 = 0;
			}
		}
//
		if(IsBitSet(bFlags2, BF_SEL_L_UP))
		{
			BitClear(bFlags2, BF_SEL_L_UP);
			BitClear(bFlags2, BF_SEL_L_PUSHING);
		}
		if(IsBitSet(bFlags2, BF_SEL_R_UP))
		{
			BitClear(bFlags2, BF_SEL_R_UP);
			BitClear(bFlags2, BF_SEL_R_PUSHING);
		}

		if(IsBitSet(bFlags, BF_SEL_L_PUSH))
		{
			if(idxCur < (cnEntry - 1))
				idxCur ++;
			BitClear(bFlags2, BF_ENTER_DBLCLK);
			BitClear(bFlags, BF_SEL_L_PUSH);
			BitSet(bFlags2, BF_SEL_L_PUSHING);
		}

		if(IsBitSet(bFlags, BF_SEL_R_PUSH))
		{
			if(idxCur > 0)
				idxCur --;
			BitClear(bFlags, BF_SEL_R_PUSH);
			BitClear(bFlags2, BF_ENTER_DBLCLK);
			BitSet(bFlags2, BF_SEL_R_PUSHING);
		}

		if(IsBitSet(bFlags, BF_SEL_U_PUSH))
		{
			if(idxCur < cnEntry)
				if(uAngle < 50)
					uAngle++;
			BitClear(bFlags, BF_SEL_U_PUSH);
			BitClear(bFlags2, BF_ENTER_DBLCLK);
		}
		if(IsBitSet(bFlags, BF_SEL_D_PUSH))
		{
			if(idxCur < cnEntry)
				if(uAngle > 0)
					uAngle--;
			BitClear(bFlags, BF_SEL_D_PUSH);
			BitClear(bFlags2, BF_ENTER_DBLCLK);
		}

		if(IsBitSet(bFlags, BF_ENTER_PUSH))
		{
			if(IsBitSet(bFlags2, BF_ENTER_DBLCLK))	// ENTER 2xAŉꂽ
			{
				retry = 3;
				while(retry)
				{
					if(USARTPutDatas(3, _SCMDS_FINISH) != 0)
					{
						nError = 21;
						goto	LERROR;
					}

					uTemp = USARTGetByte(&uRet, CNT_1S_1024DIV);
					if(uRet == 0xff)
					{
						nError = 22;
						goto	LERROR;
					}
					if(uTemp == _RCMD_OK)
					{
						LCDPutLine(0, "FINISH") ;
						LCDPutLine(1, "REBOOT!");
						
						return  0;			// ZbgAbvI
					}
				}
			}
			if(idxCur < cnEntry)
			{
				if(IsBitSet(bFlags2, BF_MODIFY))
				{
					retry = 3;
					uSends[0]	=	_SCMD_SETAT0;	
					uSends[1]	=	_SCMD_SETAT1;
					uSends[2]	=	uAngle;
					while(retry)
					{
						if(USARTPutDatas(3, uSends) != 0)
						{
							nError = 11;
							goto	LERROR;
						}
						uTemp = USARTGetByte(&uRet, CNT_1S_1024DIV);
						if(uRet == 0xff)
						{
							nError = 12;
							goto	LERROR;
						}
						if(uTemp == _RCMD_OK)
						{
							BitClear(bFlags2, BF_MODIFY);
							break;
						}
					}
					if(retry < 1)
					{
						nError = 14;
						goto	LERROR;
					}
				}
			}
			else
			{
				idxCur--;							// "SETTING MODE"̂܂ܑ̃{^ȂꍇA{^Ɠ
			}
			BitSet(bFlags2, BF_ENTER_DBLCLK);
			BitClear(bFlags, BF_ENTER_PUSH);
		}

		if(idxCur != idxPrev)
		{
			uSends[0]	=	_SCMD_GETAT0;	
			uSends[1]	=	_SCMD_GETAT1;
			uSends[2]	=	idxCur;
			do
			{
				if(USARTPutDatas(3, uSends) != 0)
				{
					nError = 4;
					goto	LERROR;
				}
				uAngle = USARTGetByte(&uRet, CNT_1S_1024DIV);
			}while(uRet == 1);
			if(uRet == 0xff || uAngle == _RCMD_BAD)
			{
				nError = 5;
				goto	LERROR;
			}
			LCDPutsNumeric(LCD_DIST_LEFT, (uMaxRpmP100 - idxCur)* 100) ;
			LCDPutsNumeric(LCD_DIST_RIGHT, uAngle) ;
			idxPrev = idxCur;
			uAngleSav = uAngle;
		}

		if(uAngle != uAngleSav)
		{
			LCDPutsNumeric(LCD_DIST_RIGHT, uAngle) ;
			uAngleSav = uAngle;
			BitSet(bFlags2, BF_MODIFY);
		}

	}

	// ʐMMpƂ
	UCSRB	= (1 << RXEN);

	//	LCD NA
	LCDClear(LCD_DIST_LEFT);
	LCDClear(LCD_DIST_RIGHT);

	while(1)
	{
		if(IsBitSet(UCSRA, RXC))
		{
			uTemp	= UDR;
			uCalc	= (uMaxRpmP100 - uTemp) * 100;	// ő]0Ƃ]CfNX]𓾂		
			LCDPutsNumeric(LCD_DIST_RIGHT, uCalc);
		}
	}
	return  0;
LERROR:
	LCDPutLine(LCD_DIST_LEFT, "ERROR") ;
	LCDPutsNumeric(LCD_DIST_RIGHT, nError);
	return  -1;
}

